Bug 1103420 - Review Request: autowrap - Generates Python Extension modules from [Cython] PXD files
Summary: Review Request: autowrap - Generates Python Extension modules from [Cython] P...
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jerry James
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: 1114737
TreeView+ depends on / blocked
 
Reported: 2014-05-31 10:23 UTC by Antonio Trande
Modified: 2014-08-16 00:30 UTC (History)
3 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2014-08-16 00:29:14 UTC
loganjerry: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Antonio Trande 2014-05-31 10:23:24 UTC
Spec URL: http://sagitter.fedorapeople.org/python-autowrap/python-autowrap.spec
SRPM URL: http://sagitter.fedorapeople.org/python-autowrap/python-autowrap-0.2.14-1.20140321git26e901.fc20.src.rpm

Description: This module uses the Cython "header" .pxd files to automatically generate Cython input (.pyx) files. It does so by parsing the header files and possibly annotations in the header files to generate correct Cython code.

Fedora Account System Username: sagitter

Comment 1 Björn 'besser82' Esser 2014-05-31 11:37:37 UTC
* Source0 has invalid URL:
  INFO: Downloading (Source0): https://github.com/uweschmitt/autowrap/archive/autowrap-26e9016e3f99dbe746bd1e09d13ce65f836c8531.zip
  WARNING: Cannot download url: https://github.com/uweschmitt/autowrap/archive/autowrap-26e9016e3f99dbe746bd1e09d13ce65f836c8531.zip
  INFO: No upstream for (Source0): autowrap-26e9016e3f99dbe746bd1e09d13ce65f836c8531.zip

  ---> Please change Source0 to a working URL [1]


* Version: 0.2.14 -- dafuq?

  ---> According to git-log in [2] upstream released 0.4.0 on 2014-02-04.


[1]  https://github.com/uweschmitt/autowrap/archive/%{commit}.tar.gz
[2]  https://github.com/uweschmitt/autowrap/commits/master

Comment 2 Antonio Trande 2014-05-31 12:56:26 UTC
(In reply to Björn "besser82" Esser from comment #1)
> * Source0 has invalid URL:
>   INFO: Downloading (Source0):
> https://github.com/uweschmitt/autowrap/archive/autowrap-
> 26e9016e3f99dbe746bd1e09d13ce65f836c8531.zip
>   WARNING: Cannot download url:
> https://github.com/uweschmitt/autowrap/archive/autowrap-
> 26e9016e3f99dbe746bd1e09d13ce65f836c8531.zip
>   INFO: No upstream for (Source0):
> autowrap-26e9016e3f99dbe746bd1e09d13ce65f836c8531.zip
> 
>   ---> Please change Source0 to a working URL [1]

Download link does not end with related zipped archive.
Fixed.

> 
> 
> * Version: 0.2.14 -- dafuq?
> 
>   ---> According to git-log in [2] upstream released 0.4.0 on 2014-02-04.
> 
> 
> [1]  https://github.com/uweschmitt/autowrap/archive/%{commit}.tar.gz
> [2]  https://github.com/uweschmitt/autowrap/commits/master

Fixed.

Spec URL: http://sagitter.fedorapeople.org/python-autowrap/python-autowrap.spec
SRPM URL: http://sagitter.fedorapeople.org/python-autowrap/python-autowrap-0.4.0-1.20140321git26e901.fc20.src.rpm

Comment 3 Björn 'besser82' Esser 2014-06-01 11:37:15 UTC
Package Review
==============

Legend:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 47 files have unknown license. Detailed output of
     licensecheck in /home/besser82/shared/fedora/review/1103420-python-
     autowrap/licensecheck.txt

     ---> please ask upstream to prepend the actual license to the
          source-files.

          did you even read the LICENSE-file *BEFORE* packaging?!?

          License: GPLv3+ (spec)   vs.   License: BSD (LICENSE-file in src)

          Please refer to the process mentioned in:
          https://fedoraproject.org/wiki/Packaging/LicensingGuidelines#License_Clarification

[x]: License file installed when any subpackage combination is installed.
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/lib/python3.4, /usr/lib/python3.4/site-
     packages

     ---> owned on rawhide by python3-pkg.  false positive!

[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/python3.4/site-packages,
     /usr/lib/python3.4

     ---> owned on rawhide by python3-pkg.  false positive!

[!]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/lib/python2.7/site-
     packages/tests(python-libturpial, python-django-federated-login)

     ---> are the files in %{pythonX_sitelib}/tests even needed at runtime?
          do they serve any special purpose?  from my findings they are just
          useless clutter, because those are just a small excerpt from what
          is contained in the tarball's tests-dir.

          Double-check and use %exclude if appropriate, please!

[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[?]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package

     ---> there are some devel-files located in
          %{pythonX_sitelib}/autowrap/data_files, but they are needed for
          the intended use of the package.

[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[?]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.

     ---> according to files located in
          %{pythonX_sitelib}/autowrap/data_files there is at least
          boost-devel needed, even at runtime of the package.  Because
          the wrapper makes heavy use of boost's shared_ptr / smart_ptr.

          In conclusion to the way the package is meant to work the list
          of the minmal needed requires is:

          Requires: pythonX-devel, (python3-)Cython, boost-devel

[!]: Spec file is legible and written in American English.

     ---> spec-file has issues, refering to the packaging guidelines
          for Python-packages.

[-]: Package contains systemd file(s) if in need.
[?]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 40960 bytes in 10 files.
[!]: Package complies to the Packaging Guidelines

     ---> severe issues are present.  :(

[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[!]: Package meets the Packaging Guidelines::Python

     ---> did you even read them *BEFORE* packaging?
          please read and understand these two:

          http://fedoraproject.org/wiki/Packaging:Python#Building_more_than_once
          http://fedoraproject.org/wiki/Packaging:Python#Avoiding_collisions_between_the_python_2_and_python_3_stacks

[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[!]: Final provides and requires are sane (see attachments).

     ---> the python2-pkg requires /usr/bin/python3 ?!?

[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-autowrap

     ---> python3-subpkg is meant to be independent from main-pkg.

[!]: Package functions as described.

     ---> the python2-pkg requires /usr/bin/python3 ?!?

[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[!]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments

     ---> as I already told you in comment #1:

          https://github.com/uweschmitt/autowrap/archive/%{checkout}.tar.gz
          will give you a working url for a src-tarball.  If you'll append
          '#/%{name}-%{checkout}.tar.gz' to this you'll get a nicely named
          src-tarball when using `spectool`.

[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.

     ---> testsuite is NOT run with Python3.

[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[!]: SourceX is a working URL.

     ---> as commented above

[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python-autowrap-0.4.0-1.20140321git26e901.fc21.noarch.rpm
          python3-autowrap-0.4.0-1.20140321git26e901.fc21.noarch.rpm
          python-autowrap-0.4.0-1.20140321git26e901.fc21.src.rpm
python-autowrap.noarch: W: spelling-error %description -l en_US pxd -> pd, pad, pod
python-autowrap.noarch: W: devel-file-in-non-devel-package /usr/lib/python2.7/site-packages/autowrap/data_files/autowrap_tools.hpp

---> this one is needed for the package to function properly.  It's used
     for 'autowrapping'.  false positive!

python-autowrap.noarch: W: no-manual-page-for-binary autowrap
python3-autowrap.noarch: E: python-bytecode-wrong-magic-value /usr/lib/python3.4/site-packages/autowrap/__pycache__/Types.cpython-34.pyo expected 3260 (3.4), found 3310 (unknown)
… snip …
python3-autowrap.noarch: E: python-bytecode-wrong-magic-value /usr/lib/python3.4/site-packages/autowrap/__pycache__/ConversionProvider.cpython-34.pyc expected 3260 (3.4), found 3310 (unknown)

---> this warning is a bug in rpmlint, which needs to be fixed there.
     false positive!

python3-autowrap.noarch: W: no-manual-page-for-binary autowrap
python-autowrap.src: W: spelling-error %description -l en_US pxd -> pd, pad, pod
python-autowrap.src: W: invalid-url Source0: autowrap-26e9016e3f99dbe746bd1e09d13ce65f836c8531.zip

---> as stated above.

3 packages and 0 specfiles checked; 32 errors, 7 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint python-autowrap python3-autowrap
python-autowrap.noarch: W: spelling-error %description -l en_US pxd -> pd, pad, pod
python-autowrap.noarch: W: devel-file-in-non-devel-package /usr/lib/python2.7/site-packages/autowrap/data_files/autowrap_tools.hpp
python-autowrap.noarch: W: no-manual-page-for-binary autowrap
python3-autowrap.noarch: W: devel-file-in-non-devel-package /usr/lib/python3.4/site-packages/autowrap/data_files/autowrap_tools.hpp
python3-autowrap.noarch: W: no-manual-page-for-binary autowrap
2 packages and 0 specfiles checked; 0 errors, 5 warnings.
# echo 'rpmlint-done:'

---> as commented above.


Requires
--------
python-autowrap (rpmlib, GLIBC filtered):
    /usr/bin/python3

---> dafuq?

    python(abi)

python3-autowrap (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)



Provides
--------
python-autowrap:
    python-autowrap

python3-autowrap:
    python3-autowrap



Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1103420
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG


===== Additional Information =====

* When thiking about the pkg's Requires and the intended functionality, I'm
  *strongly* tending to the conclusion, this *MUST* be arch'ed and needs to
  have %{?_isa}-Requires…

* There is lots of rrom for improvement is the spec-file, but let's defer
  this to a point, when all severe issues are fixed up.

* If you need help on packaging this correctly, you can contact me directly
  using IRC (besser82 in #fedora-devel, #fedora-mentors) or email (address
  is mentioned in rhbz comment headers).


===== Solution =====

NOT approved; severe issues found!  Please fix those and I'll take another run on the package.

Comment 4 Antonio Trande 2014-06-01 22:31:47 UTC
My approach with this package has been vague.
Now it should be better.

SPEC: http://sagitter.fedorapeople.org/python-autowrap/autowrap.spec
SRPM: http://sagitter.fedorapeople.org/python-autowrap/autowrap-0.4.0-2.20140321git26e901.fc20.src.rpm

- Fixed License
- Fixed Requires package for python2/python3
- Excluded 'tests' directories by packaging
- Performing building operations to packaging independent Python3 module
- Disabled generation of the useless debuginfo package

Comment 5 Antonio Trande 2014-06-02 10:50:41 UTC
(In reply to Björn "besser82" Esser from comment #3)
> Package Review
> ==============
> 
> Legend:
> [x] = Pass
> [!] = Fail
> [-] = Not applicable
> [?] = Not evaluated
> 
> 
> [!]: License field in the package spec file matches the actual license.
>      Note: Checking patched sources after %prep for licenses. Licenses found:
>      "Unknown or generated". 47 files have unknown license. Detailed output
> of
>      licensecheck in /home/besser82/shared/fedora/review/1103420-python-
>      autowrap/licensecheck.txt
> 
>      ---> please ask upstream to prepend the actual license to the
>           source-files.
> 
>           did you even read the LICENSE-file *BEFORE* packaging?!?
> 
>           License: GPLv3+ (spec)   vs.   License: BSD (LICENSE-file in src)
> 
>           Please refer to the process mentioned in:
>          
> https://fedoraproject.org/wiki/Packaging/
> LicensingGuidelines#License_Clarification


I had not checked License file; it was a my mistake.
https://github.com/uweschmitt/autowrap/issues/6

SPEC: http://sagitter.fedorapeople.org/python-autowrap/autowrap.spec
SRPM: http://sagitter.fedorapeople.org/python-autowrap/autowrap-0.4.0-3.20140321git26e901.fc20.src.rpm

- Removed conditional macros for EPEL
- Fixed Source0

Comment 6 Antonio Trande 2014-06-02 10:54:33 UTC
Koji build in rawhide: http://koji.fedoraproject.org/koji/taskinfo?taskID=6917582

Comment 9 Antonio Trande 2014-06-11 22:05:34 UTC
- Fixed nosetests command according to new default python3 stack on Fedora 21+

SPEC: http://sagitter.fedorapeople.org/python-autowrap/autowrap.spec
SRPM: http://sagitter.fedorapeople.org/python-autowrap/autowrap-0.5.0-2.20140603git1753b9.fc20.src.rpm

Comment 10 Antonio Trande 2014-06-29 18:15:59 UTC
Björn, please, can we go on?

Comment 11 Antonio Trande 2014-07-29 17:51:59 UTC
Björn seems too busy in this time. I thank him in any case.
I set fedora‑review flag to empty.

Comment 12 Jerry James 2014-07-29 18:28:51 UTC
I will take this review.

Comment 13 Jerry James 2014-07-29 21:34:24 UTC
Issues:
1. The package Requires are not right.  The Requires that should be in the
   python3 subpackage are in the main package instead.  But the Requires
   declaration for the python3 subpackage under "%package -n python3-autowrap".

2. Having said that, why are python2-devel/python3-devel needed?  I can see
   the need for Cython and boost-devel, but why pythonX-devel?

3. I am not convinced that this package should be archful.  What can go wrong
   if it is noarch?  Also, rpmdiff shows that the only differences between
   i386 and x86_64 builds are in the byte compiled python files, which is
   probably just timestamp differences.  So if something can go wrong if the
   package is noarch, then I believe that same thing will go wrong with the
   package as it is currently constituted. (Note also that the files are
   installed in %{pythonX_sitelib}, which is for non-arch-specific modules;
   they would go in %{pythonX_sitearch} otherwise.)

4. I question the usefulness of including CONCEPT and README_DEVELOP in %doc.
   Those do not seem to provide any information that users of this package
   will need.

5. The entry "%{__python3}-autowrap" in the python3 %files section is, in my
   opinion, an abuse of the %{__python3} macro.  Please change that to read
   "%{_bindir}/python3-autowrap".

6. What is the purpose of the "find ... | sed ..." invocations in %prep?  As
   far as I can see, they do exactly nothing.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated



===== MUST items =====

C/C++:
[-]: Provides: bundled(gnulib) in place as required.
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 40960 bytes in 10 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[!]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: autowrap-0.5.0-2.20140603git1753b9.fc22.x86_64.rpm
          python3-autowrap-0.5.0-2.20140603git1753b9.fc22.x86_64.rpm
          autowrap-0.5.0-2.20140603git1753b9.fc22.src.rpm
autowrap.x86_64: E: devel-dependency boost-devel
autowrap.x86_64: W: spelling-error %description -l en_US pxd -> pd, pad, pod
autowrap.x86_64: E: no-binary
autowrap.x86_64: W: devel-file-in-non-devel-package /usr/lib/python2.7/site-packages/autowrap/data_files/autowrap_tools.hpp
autowrap.x86_64: W: no-manual-page-for-binary autowrap
python3-autowrap.x86_64: W: devel-file-in-non-devel-package /usr/lib/python3.4/site-packages/autowrap/data_files/autowrap_tools.hpp
python3-autowrap.x86_64: W: no-manual-page-for-binary python3-autowrap
autowrap.src: W: spelling-error %description -l en_US pxd -> pd, pad, pod
3 packages and 0 specfiles checked; 2 errors, 6 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint autowrap python3-autowrap
autowrap.x86_64: E: devel-dependency boost-devel
autowrap.x86_64: W: spelling-error %description -l en_US pxd -> pd, pad, pod
autowrap.x86_64: E: no-binary
autowrap.x86_64: W: devel-file-in-non-devel-package /usr/lib/python2.7/site-packages/autowrap/data_files/autowrap_tools.hpp
autowrap.x86_64: W: no-manual-page-for-binary autowrap
python3-autowrap.x86_64: W: devel-file-in-non-devel-package /usr/lib/python3.4/site-packages/autowrap/data_files/autowrap_tools.hpp
python3-autowrap.x86_64: W: no-manual-page-for-binary python3-autowrap
2 packages and 0 specfiles checked; 2 errors, 5 warnings.
# echo 'rpmlint-done:'



Requires
--------
autowrap (rpmlib, GLIBC filtered):
    /usr/bin/python2
    Cython
    boost-devel
    python(abi)
    python2-devel
    python3-Cython
    python3-devel

python3-autowrap (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)



Provides
--------
autowrap:
    autowrap
    autowrap(x86-64)

python3-autowrap:
    python3-autowrap
    python3-autowrap(x86-64)



Source checksums
----------------
https://github.com/uweschmitt/autowrap/archive/1753b9bf044559e18ca1ed39914405a2f8b4fca3.zip#/autowrap-1753b9bf044559e18ca1ed39914405a2f8b4fca3.zip :
  CHECKSUM(SHA256) this package     : 55437ff3b792633c188bd49d84e21ba0672c2f274b91da01571274b9017b1409
  CHECKSUM(SHA256) upstream package : 55437ff3b792633c188bd49d84e21ba0672c2f274b91da01571274b9017b1409


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1103420 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api, C/C++
Disabled plugins: Java, SugarActivity, fonts, Haskell, Ocaml, Perl, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 14 Antonio Trande 2014-07-30 14:20:25 UTC
(In reply to Jerry James from comment #13)
> Issues:
> 1. The package Requires are not right.  The Requires that should be in the
>    python3 subpackage are in the main package instead.  But the Requires
>    declaration for the python3 subpackage under "%package -n
> python3-autowrap".

Ops! Fixed.

> 
> 2. Having said that, why are python2-devel/python3-devel needed?  I can see
>    the need for Cython and boost-devel, but why pythonX-devel?

pythonX-devel files are used for testing
...
gcc -pthread -fno-strict-aliasing -O2 -g -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches -m64 -mtune=generic -D_GNU_SOURCE -fPIC -fwrapv -DNDEBUG -O2 -g -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches -m64 -mtune=generic -D_GNU_SOURCE -fPIC -fwrapv -I/usr/include/boost -fPIC *-I/usr/include/python2.7* -c itertest.cpp -o build/temp.linux-x86_64-2.7/itertest.o -Wno-unused-but-set-variable

> 
> 3. I am not convinced that this package should be archful.  What can go wrong
>    if it is noarch?  Also, rpmdiff shows that the only differences between
>    i386 and x86_64 builds are in the byte compiled python files, which is
>    probably just timestamp differences.  So if something can go wrong if the
>    package is noarch, then I believe that same thing will go wrong with the
>    package as it is currently constituted. (Note also that the files are
>    installed in %{pythonX_sitelib}, which is for non-arch-specific modules;
>    they would go in %{pythonX_sitearch} otherwise.)

This has been an explicit request in the previous review:

>> When thiking about the pkg's Requires and the intended functionality, I'm
>>  *strongly* tending to the conclusion, this *MUST* be arch'ed and needs to  >>  have %{?_isa}-Requires…

> 
> 4. I question the usefulness of including CONCEPT and README_DEVELOP in %doc.
>    Those do not seem to provide any information that users of this package
>    will need.

Well, they are informations however on software development. 

> 
> 5. The entry "%{__python3}-autowrap" in the python3 %files section is, in my
>    opinion, an abuse of the %{__python3} macro.  Please change that to read
>    "%{_bindir}/python3-autowrap".

Okay, fixed.

> 
> 6. What is the purpose of the "find ... | sed ..." invocations in %prep?  As
>    far as I can see, they do exactly nothing.
> 

They are copy residuals from another package.
Fixed.


SPEC: http://sagitter.fedorapeople.org/python-autowrap/autowrap.spec
SRPM: http://sagitter.fedorapeople.org/python-autowrap/autowrap-0.5.0-3.20140603git1753b9.fc20.src.rpm

Koji build: http://koji.fedoraproject.org/koji/taskinfo?taskID=7215646

Comment 15 Jerry James 2014-07-30 20:24:10 UTC
(In reply to Antonio Trande from comment #14)
> pythonX-devel files are used for testing

Okay, thank you for the clarification.

> This has been an explicit request in the previous review:
> 
> >> When thiking about the pkg's Requires and the intended functionality, I'm
> >>  *strongly* tending to the conclusion, this *MUST* be arch'ed and needs to  >>  have %{?_isa}-Requires…

I understand that.  But if that reasoning is correct (and I don't think it is), then this package is still inadequate for a couple of reasons:
- python2-devel and python3-devel are multi-arch, but this package Requires: pythonX-devel, not pythonX%{?_isa}-devel
- If the intention is to make this package multi-arch, you've got a problem.  Both the i386 and x86_64 builds install into %{pythonX_sitelib} (i.e., /usr/lib).  The *.py files are identical, but due to timestamps, the .pyc and .pyo files are not, so the two packages conflict.  If the intention is to NOT make this package multi-arch, then there is no point in making it arch-ful either, as only the native architecture version will be available.

But I think the reasoning behind making this package arch-ful in the first place is flawed.  This package is a code generator.  It is going to generate the same code regardless of which architecture it runs on.  *Something else* then consumes that code.  In order for the code to compile, the something else needs boost-devel, and maybe pythonX-devel.  That something else has to be arch-ful.

Summary: I think this package should be noarch, and should only Requires: Cython (which it needs to run).  It's up to whatever consumes the code that is produced by autowrap to BuildRequires: boost-devel (and maybe pythonX-devel), which will automatically make the arch correct.

> > 4. I question the usefulness of including CONCEPT and README_DEVELOP in %doc.
> >    Those do not seem to provide any information that users of this package
> >    will need.
> 
> Well, they are informations however on software development. 

Yes, they contain information on developing autowrap, but no information on developing other software *with* autowrap.  The latter is useful documentation; the former is not.  For example, here are the contents of README_DEVELOP:

------------------------------------------------------------------------------
To run the tests run nose as follows

   $ nosetests -w tests

from the projects directory
------------------------------------------------------------------------------

Users of autowrap do not want to run the nose tests.  Developers of autowrap do.  Similarly, CONCEPT contains information on how autowrap does its work internally.  This is not useful information for users of autowrap; it is useful information for developers of autowrap.

The information in %doc should be useful for the users of a package.  Developers will download the sources anyway, so they will get this information in any case.

Comment 17 Jerry James 2014-08-03 03:12:04 UTC
This package now satisfies all of the review requirements.  It is APPROVED.

Comment 18 Antonio Trande 2014-08-03 12:34:15 UTC
Thank you Jerry.

New Package SCM Request
=======================
Package Name: autowrap
Short Description: Generates Python Extension modules from [Cython] PXD files
Upstream URL: https://github.com/uweschmitt/autowrap
Owners: sagitter
Branches: f19 f20 f21

Comment 19 Gwyn Ciesla 2014-08-04 12:15:15 UTC
Git done (by process-git-requests).

Comment 20 Fedora Update System 2014-08-04 15:54:02 UTC
autowrap-0.5.0-4.20140603git1753b9.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/autowrap-0.5.0-4.20140603git1753b9.fc19

Comment 21 Fedora Update System 2014-08-04 15:54:07 UTC
autowrap-0.5.0-4.20140603git1753b9.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/autowrap-0.5.0-4.20140603git1753b9.fc20

Comment 22 Fedora Update System 2014-08-07 15:35:23 UTC
autowrap-0.5.0-4.20140603git1753b9.fc20 has been pushed to the Fedora 20 testing repository.

Comment 23 Fedora Update System 2014-08-16 00:29:14 UTC
autowrap-0.5.0-4.20140603git1753b9.fc20 has been pushed to the Fedora 20 stable repository.

Comment 24 Fedora Update System 2014-08-16 00:30:16 UTC
autowrap-0.5.0-4.20140603git1753b9.fc19 has been pushed to the Fedora 19 stable repository.


Note You need to log in before you can comment on or make changes to this bug.